package com.zd.system.service.impl;

import java.util.*;
import java.util.stream.Collectors;

import com.zd.common.core.domain.per.PerPrefix;
import com.zd.common.core.utils.SecurityUtils;
import com.zd.common.security.service.TokenService;
import com.zd.system.api.domain.SysDeptVO;
import com.zd.system.domain.vo.TreeSelectVo;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.zd.common.core.constant.UserConstants;
import com.zd.common.core.exception.ServiceException;
import com.zd.common.core.text.Convert;
import com.zd.common.core.utils.StringUtils;
import com.zd.common.datascope.annotation.DataScope;
import com.zd.system.api.domain.SysDept;
import com.zd.system.api.domain.SysRole;
import com.zd.system.domain.vo.TreeSelect;
import com.zd.system.mapper.SysDeptMapper;
import com.zd.system.mapper.SysRoleMapper;
import com.zd.system.service.ISysDeptService;
import org.springframework.transaction.annotation.Transactional;

/**
 * 部门管理 服务实现
 *
 * @author zd
 */
@Service
public class SysDeptServiceImpl implements ISysDeptService {
    @Autowired
    private SysDeptMapper deptMapper;

    @Autowired
    private SysRoleMapper roleMapper;

    @Autowired
    private TokenService tokenService;

    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    @Override
    @DataScope(deptAlias = "d", permi = PerPrefix.SYSTEM_DEPT)
    public List<SysDept> selectDeptList(SysDept dept) {
        List<SysDept> depts = deptMapper.selectDeptList(dept);
        return depts;
    }

    /**
     * 获取部门下拉树列表(获取登录人的部门父级部门)
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    @Override
    public List <SysDept> treeselectByUser(SysDept dept) {
        SysDept sysDept = deptMapper.selectDeptById(tokenService.getLoginUser().getSysUser().getDeptId());
        if(sysDept.getParentId()==0){
            dept.setParentId(sysDept.getDeptId());
        }else{
            dept.setParentId(sysDept.getParentId());
        }

        List<SysDept> depts = deptMapper.treeselectByUser(dept);
        return depts;
    }


    /**
     * 查询部门管理数据-无数据权限
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    @Override
    public List<SysDept> selectDeptListNoAuth(SysDept dept) {
        return deptMapper.selectDeptList(dept);
    }

    /**
     * 构建前端所需要树结构
     *
     * @param depts 部门列表
     * @return 树结构列表
     */
    @Override
    public List<SysDept> buildDeptTree(List<SysDept> depts) {
        List<SysDept> returnList = new ArrayList<SysDept>();
        List<Long> tempList = new ArrayList<Long>();
        for (SysDept dept : depts) {
            tempList.add(dept.getDeptId());
        }
        for (Iterator<SysDept> iterator = depts.iterator(); iterator.hasNext(); ) {
            SysDept dept = (SysDept) iterator.next();
            // 如果是顶级节点, 遍历该父节点的所有子节点
            if (!tempList.contains(dept.getParentId())) {
                recursionFn(depts, dept);
                returnList.add(dept);
            }
        }
        if (returnList.isEmpty()) {
            returnList = depts;
        }
        return returnList;
    }

    /**
     * 构建前端所需要下拉树结构
     *
     * @param depts 部门列表
     * @return 下拉树结构列表
     */
    @Override
    public List<TreeSelect> buildDeptTreeSelect(List<SysDept> depts) {
        List<SysDept> deptTrees = buildDeptTree(depts);
        return deptTrees.stream().map(TreeSelect::new).collect(Collectors.toList());
    }

    @Override
    public List <TreeSelectVo> buildDeptTreeSelectByNo(List <SysDept> depts) {
        List<SysDept> deptTrees = buildDeptTree(depts);
        return deptTrees.stream().map(TreeSelectVo::new).collect(Collectors.toList());
    }

    /**
     * 根据角色ID查询部门树信息
     *
     * @param roleId 角色ID
     * @return 选中部门列表
     */
    @Override
    public List<Integer> selectDeptListByRoleId(Long roleId) {
        SysRole role = roleMapper.selectRoleById(roleId);
        return deptMapper.selectDeptListByRoleId(roleId, role.isDeptCheckStrictly());
    }

    /**
     * 根据部门ID查询信息
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    @Override
    public SysDept selectDeptById(Long deptId) {
        return deptMapper.selectDeptById(deptId);
    }

    /**
     * 根据ID查询所有子部门（正常状态）
     *
     * @param deptId 部门ID
     * @return 子部门数
     */
    @Override
    public int selectNormalChildrenDeptById(Long deptId) {
        return deptMapper.selectNormalChildrenDeptById(deptId);
    }

    /**
     * 是否存在子节点
     *
     * @param deptId 部门ID
     * @return 结果
     */
    @Override
    public boolean hasChildByDeptId(Long deptId) {
        int result = deptMapper.hasChildByDeptId(deptId);
        return result > 0 ? true : false;
    }

    /**
     * 查询部门是否存在用户
     *
     * @param deptId 部门ID
     * @return 结果 true 存在 false 不存在
     */
    @Override
    public boolean checkDeptExistUser(Long deptId) {
        int result = deptMapper.checkDeptExistUser(deptId);
        return result > 0 ? true : false;
    }

    /**
     * 校验部门名称是否唯一
     *
     * @param dept 部门信息
     * @return 结果
     */
    @Override
    public String checkDeptNameUnique(SysDept dept) {
        Long deptId = StringUtils.isNull(dept.getDeptId()) ? -1L : dept.getDeptId();
        SysDept info = deptMapper.checkDeptNameUnique(dept.getDeptName(), dept.getParentId());
        if (StringUtils.isNotNull(info) && info.getDeptId().longValue() != deptId.longValue()) {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 新增保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    @Override
    public int insertDept(SysDept dept) {
        SysDept info = deptMapper.selectDeptById(dept.getParentId());
        // 如果父节点不为正常状态,则不允许新增子节点
        if (!UserConstants.DEPT_NORMAL.equals(info.getStatus())) {
            throw new ServiceException("部门停用，不允许新增");
        }
        dept.setAncestors(info.getAncestors() + "," + dept.getParentId());
        return deptMapper.insertDept(dept);
    }


    /**
     * 新增保存部门信息 (教师专用)
     *
     * @param deptVO 部门信息
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDeptByTeaCher(SysDeptVO deptVO) {
        for(SysDept dept : deptVO.getTeaCherDpetList()){
            dept.setCreateBy(SecurityUtils.getUsername());
            SysDept info = deptMapper.selectDeptById(dept.getParentId());
            // 如果父节点不为正常状态,则不允许新增子节点
            if (!UserConstants.DEPT_NORMAL.equals(info.getStatus())) {
                throw new ServiceException("部门停用，不允许新增");
            }
            dept.setAncestors(info.getAncestors() + "," + dept.getParentId());
            //这里需要查询平级最大的排序号
            if(dept.getParentId()!=null){
                int maxNum = deptMapper.selectMaxNumChildrenDeptById(dept.getParentId());
                dept.setOrderNum(maxNum+"");
            }
            deptMapper.insertDept(dept);
        }
        return 1;
    }

    /**
     * 部门排序 "system:dept:edit"    (教师专用)
     *
     * @param deptVO 部门信息
     * @return 结果
     */
    @Override
    public int editDeptOrder(SysDeptVO deptVO) {
        List<SysDept> sysDeptList = deptMapper.selectDownDeptListById(deptVO.getParentId());
        int maxNum = deptMapper.selectMaxNumChildrenDeptById(deptVO.getParentId());
        Boolean lastAct = false;
        if(deptVO.getUpDownOper()==1){
            //向上移动和向下一定一样，需要数据翻转
            Collections.reverse(sysDeptList);
            for(SysDept dept:sysDeptList){
                if(lastAct){
                    Integer orderNum = Integer.parseInt(dept.getOrderNum())+1;
                    SysDept sysDept = new SysDept();
                    sysDept.setDeptId(dept.getDeptId());
                    sysDept.setOrderNum(orderNum+"");
                    deptMapper.updateDept(sysDept);
                    lastAct = false;
                }
                if(deptVO.getDeptId() == dept.getDeptId() || deptVO.getDeptId().equals(dept.getDeptId())){
                    Integer orderNum = Integer.parseInt(dept.getOrderNum())-1;
                    if(orderNum>=0){
                        lastAct = true;
                        SysDept sysDept = new SysDept();
                        sysDept.setDeptId(dept.getDeptId());
                        sysDept.setOrderNum(orderNum+"");
                        deptMapper.updateDept(sysDept);
                    }else{
                        throw new ServiceException("已经移到最顶部了，不能再向下了！！");
                    }
                }

            }
        }else if(deptVO.getUpDownOper()==2){
            for(SysDept dept:sysDeptList){
                if(lastAct){
                    Integer orderNum = Integer.parseInt(dept.getOrderNum())-1;
                    SysDept sysDept = new SysDept();
                    sysDept.setDeptId(dept.getDeptId());
                    sysDept.setOrderNum(orderNum+"");
                    deptMapper.updateDept(sysDept);
                    lastAct = false;
                }
                if(deptVO.getDeptId() == dept.getDeptId() || deptVO.getDeptId().equals(dept.getDeptId())){
                    Integer orderNum = Integer.parseInt(dept.getOrderNum())+1;
                    if(orderNum<maxNum){
                        lastAct = true;
                        SysDept sysDept = new SysDept();
                        sysDept.setDeptId(dept.getDeptId());
                        sysDept.setOrderNum(orderNum+"");
                        deptMapper.updateDept(sysDept);
                    }else{
                        throw new ServiceException("已经移到最底部了，不能再向下了！！");
                    }
                }

            }
        }else{
            throw new ServiceException("排序参数错误，请联系管理员");
        }
        return 1;
    }


    /**
     * 修改保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    @Override
    public int updateDept(SysDept dept) {
        SysDept newParentDept = deptMapper.selectDeptById(dept.getParentId());
        SysDept oldDept = deptMapper.selectDeptById(dept.getDeptId());
        if (StringUtils.isNotNull(newParentDept) && StringUtils.isNotNull(oldDept)) {
            String newAncestors = newParentDept.getAncestors() + "," + newParentDept.getDeptId();
            String oldAncestors = oldDept.getAncestors();
            dept.setAncestors(newAncestors);
            updateDeptChildren(dept.getDeptId(), newAncestors, oldAncestors);
        }
        //这里需要查询平级最大的排序号
        if(dept.getParentId()!=null){
            int maxNum = deptMapper.selectMaxNumChildrenDeptById(dept.getParentId());
            dept.setOrderNum(maxNum+"");
        }
        int result = deptMapper.updateDept(dept);
        if (UserConstants.DEPT_NORMAL.equals(dept.getStatus()) && StringUtils.isNotEmpty(dept.getAncestors())
                && !StringUtils.equals("0", dept.getAncestors())) {
            // 如果该部门是启用状态，则启用该部门的所有上级部门
            updateParentDeptStatusNormal(dept);
        }
        return result;
    }


    /**
     * 修改部门名称
     *
     * @param dept 部门信息
     * @return 结果
     */
    @Override
    public int updateDeptName(SysDept dept) {
        int result = deptMapper.updateDept(dept);
        return result;
    }

    /**
     * 修改该部门的父级部门状态
     *
     * @param dept 当前部门
     */
    private void updateParentDeptStatusNormal(SysDept dept) {
        String ancestors = dept.getAncestors();
        Long[] deptIds = Convert.toLongArray(ancestors);
        deptMapper.updateDeptStatusNormal(deptIds);
    }

    /**
     * 修改子元素关系
     *
     * @param deptId       被修改的部门ID
     * @param newAncestors 新的父ID集合
     * @param oldAncestors 旧的父ID集合
     */
    public void updateDeptChildren(Long deptId, String newAncestors, String oldAncestors) {
        List<SysDept> children = deptMapper.selectChildrenDeptById(deptId);
        for (SysDept child : children) {
            child.setAncestors(child.getAncestors().replaceFirst(oldAncestors, newAncestors));
        }
        if (children.size() > 0) {
            deptMapper.updateDeptChildren(children);
        }
    }

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @return 结果
     */
    @Override
    public int deleteDeptById(Long deptId) {
        deptMapper.deleteDeptById(deptId);
        //查询部分父节点下的所有子节点
        SysDept sysDept = deptMapper.selectDeptById(deptId);
        List<SysDept> sysDeptList = deptMapper.selectChildrenDeptListById(sysDept.getParentId());
        Boolean lineCompletion = false;
        for(SysDept dept:sysDeptList){
            if(lineCompletion){
                Integer orderNum = Integer.parseInt(dept.getOrderNum())-1;
                SysDept newSysDept = new SysDept();
                newSysDept.setDeptId(dept.getDeptId());
                newSysDept.setOrderNum(orderNum+"");
                deptMapper.updateDept(newSysDept);
            }
            if(deptId==dept.getDeptId() || deptId.equals(dept.getDeptId())){
                lineCompletion = true;
            }
        }
//        if(lineCompletion){
//
//        }
        return 1;
    }

    @Override
    public List<Long> selectAllParentId(List<Long> ids) {
        String data = deptMapper.selectAllParentId(ids);

        List<Long> list= Arrays.asList(data .split(",")).stream().map(s -> (Long.parseLong(s.trim()))).collect(Collectors.toList());

        ids.addAll(list);
        ids = ids.stream().distinct().collect(Collectors.toList());
        return ids;
    }

    @Override
    @DataScope(deptAlias = "d", permi = PerPrefix.SYSTEM_DEPT)
    public List<SysDept> selectBuildsList(SysDept dept) {
        return deptMapper.selectBuildsList(dept);
    }

    @Override
    public SysDept updateDeptSign(SysDept dept) {

        SysDept sysDept = new SysDept();
        sysDept.setDeptId(dept.getDeptId());
        sysDept.setDeptSign(dept.getDeptSign());
        sysDept.setIsLower(dept.getIsLower());
        deptMapper.updateDept(sysDept);
        return dept;
    }

    /**
     * 用户查询是否有电子签章
     */
    @Override
    public Map<String, Object> queryDeptSignByUserId(Long userId) {

        String deptSignUrl = deptMapper.queryDeptSignByUserId(userId);
        Map<String, Object> map = new HashMap<>();

        map.put("isUpload", StringUtils.isNotBlank(deptSignUrl) ? true : false);
        map.put("deptSignUrl", deptSignUrl);
        return map;
    }


    @Override
    @DataScope(deptAlias = "d", permi = PerPrefix.SYSTEM_DEPT)
    public List<SysDept> selectDeptListByCollege(SysDept dept) {
        return deptMapper.selectDeptListByCollege(dept);
    }

    @Override
    public List<SysDept> selectChildrenDeptListById(Long deptId) {
        return deptMapper.selectChildrenDeptListById(deptId);
    }

    /**
     * 递归列表
     */
    private void recursionFn(List<SysDept> list, SysDept t) {
        // 得到子节点列表
        List<SysDept> childList = getChildList(list, t);
        t.setChildren(childList);
        for (SysDept tChild : childList) {
            if (hasChild(list, tChild)) {
                recursionFn(list, tChild);
            }
        }
    }

    /**
     * 得到子节点列表
     */
    private List<SysDept> getChildList(List<SysDept> list, SysDept t) {
        List<SysDept> tlist = new ArrayList<SysDept>();
        Iterator<SysDept> it = list.iterator();
        while (it.hasNext()) {
            SysDept n = (SysDept) it.next();
            if (StringUtils.isNotNull(n.getParentId()) && n.getParentId().longValue() == t.getDeptId().longValue()) {
                tlist.add(n);
            }
        }
        return tlist;
    }

    /**
     * 判断是否有子节点
     */
    private boolean hasChild(List<SysDept> list, SysDept t) {
        return getChildList(list, t).size() > 0 ? true : false;
    }
}
